#!/usr/bin/perl

#
# Script: process_fsio.pl
# Version: 1.0
# Release Date: 4-Nov-2011
# Author: Alan Ford
#
# Compatiblity: RHEL 4 & 5, Solaris 9
#
# Description: This script processes data from the fsio data feeders.
#
# Note:
#

use Time::Local;

$today = localtime();

@colours = ("#00FFFF", "#7FFFD4", "#A52A2A", "#5F9EA0", "#7FFF00", "#6496ED",
            "#FF00FF", "#FFD700", "#ADFF2F", "#708090", "#C0C0C0", "#4149E1",
            "#9ACD32", "#FFFF00", "#00FF7F", "#FA8072", "#FF0000", "#FFDAB9",
            "#C71585", "#3CB371", "#9370D8", "#800000", "#D3D3D3", "#F0E68C",
            "#B22222", "#B22222", "#B22222", "#B22222", "#B22222", "#B22222");

$colour_count = 0;

$hostname = $ARGV[0];
$service = $ARGV[1];
$data_file = $ARGV[2];


open( FILE, "< $data_file" );

$old_filesystem = "";

while( <FILE> ) {

  $_ = <FILE> if ( /^data / );

  chomp;

  ($timestamp, $test, $filesystem, $disk, $data) = split/;/;

# Debug stuff.. 

#  print "$timestamp\n";
#  print "$test\n";
#  print "$filesystem\n";
#  print "$disk\n";
#  print "$data\n";

  $disk_pre = '';
  $disk_pre = "/dev/" if ( $disk =~ s/^\/dev\/// );

  $IOSTAT{$disk} = $data if ( $IOSTAT{$disk} eq "" );

  $COLOUR{$disk} = $colours[$colour_count++] if ( $COLOUR{$disk} eq "" );
  
  if ( $old_filesystem ne $filesystem ) {

    $fsio_status_output = "$fsio_status_output<BR><BR><font color=#FFFFFF>$filesystem</font>";
    $fsio_status_output = "$fsio_status_output<BR>         <font color=$COLOUR{$disk}>$disk_pre$disk</font>";
    $old_filesystem = $filesystem;

  } else {

    $fsio_status_output = "$fsio_status_output<BR>         <font color=$COLOUR{$disk}>$disk_pre$disk</font>";

  }
#  print $IOSTAT{$disk};
}

$fsio_status_output = "$fsio_status_output <BR><!--";

foreach $disk (sort keys %IOSTAT) {

#  $fsio_status_output = "$fsio_status_output<BR><font color=$COLOUR{$disk}>$disk_pre$disk:</font>\n";
  $fsio_status_output = "$fsio_status_output$disk_pre$disk:\n";

# Setup DS for this check.

  print "DS:read_sec:GAUGE:600:0:U\n";     # Reads per sec
  print "DS:write_sec:GAUGE:600:0:U\n";    # Writes per sec
  print "DS:kread_sec:GAUGE:600:0:U\n";    # kilobytes read per second
  print "DS:kwrite_sec:GAUGE:600:0:U\n";   # kilobytes written per second
  print "DS:wait:GAUGE:600:0:U\n";         # average number of  transactions  waiting  for  service (queue length)
  print "DS:actv:GAUGE:600:0:U\n";         # average number of transactions actively being serviced (removed from the queue but not yet completed)
  print "DS:wsvc_t:GAUGE:600:0:U\n";       # average service time in wait queue, in milliseconds
  print "DS:asvc_t:GAUGE:600:0:U\n";       # average service  time  active  transactions, in milliseconds
  print "DS:pwait:GAUGE:600:0:U\n";
  print "DS:pbusy:GAUGE:600:0:U\n";        # % utilisation

  # New rrd filename

print "$service,$disk.rrd\n";

# Data

print "$IOSTAT{$disk}\n";

}
$fsio_status_output = "$fsio_status_output -->";

`$ENV{BB} xymon.stanwell.com "status $hostname.$service green $today - File System (Disk IO Read/Write) $fsio_status_output"`;
`$ENV{BB} xymon.stanwell.com "status $hostname.fsio2 green $today - File System (Disk IO Utilization) $fsio_status_output"`;
